<?xml version="1.0" encoding="UTF-8"?>
<beans:beans xmlns="http://www.springframework.org/schema/mvc"
             xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:beans="http://www.springframework.org/schema/beans"
             xmlns:context="http://www.springframework.org/schema/context" xmlns:tx="http://www.springframework.org/schema/tx"
             xsi:schemaLocation="http://www.springframework.org/schema/mvc http://www.springframework.org/schema/mvc/spring-mvc.xsd
        http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans.xsd
        http://www.springframework.org/schema/context http://www.springframework.org/schema/context/spring-context.xsd
        http://www.springframework.org/schema/tx http://www.springframework.org/schema/tx/spring-tx-4.0.xsd">

       <!-- DispatcherServlet Context: defines this servlet's request-processing
           infrastructure -->

       <!-- Enables the Spring MVC @Controller programming model -->
       <annotation-driven />
       <context:component-scan base-package="teams"/>

       <!-- Handles HTTP GET requests for /resources/** by efficiently serving
           up static resources in the ${webappRoot}/resources directory -->
       <resources mapping="/resources/**" location="/resources/" />

       <!-- Resolves views selected for rendering by @Controllers to .jsp resources
           in the /WEB-INF/views directory -->
       <beans:bean
               class="org.springframework.web.servlet.view.InternalResourceViewResolver">
              <beans:property name="prefix" value="/WEB-INF/views/" />
              <beans:property name="suffix" value=".jsp" />
       </beans:bean>

        <!-- Database connection Bean definition -->
       <beans:bean id="dataSource" class="org.apache.commons.dbcp.BasicDataSource"
                   destroy-method="close">
              <beans:property name="driverClassName" value="com.mysql.jdbc.Driver" />
              <beans:property name="url"
                              value="jdbc:mysql://localhost:3306/teams" />
              <beans:property name="username" value="root" />
              <beans:property name="password" value="root" />
       </beans:bean>

       <!-- Hibernate 4 SessionFactory Bean definition -->
       <beans:bean id="hibernate4AnnotatedSessionFactory"
                   class="org.springframework.orm.hibernate4.LocalSessionFactoryBean">
              <beans:property name="dataSource" ref="dataSource"/>
              <beans:property name="annotatedClasses">
                     <beans:list>
                            <beans:value>teams.model.Team</beans:value>
                     </beans:list>
              </beans:property>
              <beans:property name="hibernateProperties">
                     <beans:props>
                            <beans:prop key="hibernate.dialect">org.hibernate.dialect.MySQLDialect
                            </beans:prop>
                            <beans:prop key="hibernate.show_sql">true</beans:prop>
                            <beans:prop key="hibernate.hbm2ddl.auto">create</beans:prop>
                            <beans:prop key="hibernate.connection.charset">UTF-8</beans:prop>
                     </beans:props>
              </beans:property>
       </beans:bean>

        <!-- DAO and Service Beans definition -->
       <beans:bean id="teamDAO" class="teams.dao.TeamDAOImpl">
              <beans:property name="sessionFactory" ref="hibernate4AnnotatedSessionFactory" />
       </beans:bean>
       <beans:bean id="teamService" class="teams.service.TeamServiceImpl">
              <beans:property name="teamDAO" ref="teamDAO"></beans:property>
       </beans:bean>

    <!-- Enabling Transaction manager -->
       <tx:annotation-driven transaction-manager="transactionManager"/>

    <!-- Config Transaction Manager -->
       <beans:bean id="transactionManager" class="org.springframework.orm.hibernate4.HibernateTransactionManager">
              <beans:property name="sessionFactory" ref="hibernate4AnnotatedSessionFactory" />
       </beans:bean>

</beans:beans>